#%RAML 0.8
title: Hack.Space Client
version: v0.3.0
baseUri: /api

securitySchemes:
  - JWT:
      type: x-JWT
      description:
        This API uses JWT to authenticate the requests.
        See jwt.io for more information.
      describedBy:
        headers:
          Authorization:
            description: |
              Should contain the JWT token.
              Format of the value is : JWT $token
        responses:
          401:
            description: Missing or invalid JWT token
            body:
              application/json:
                example: |
                  { "message":"Missing/incorrect JWT" }
          403:
            description: Insufficient privileges
            body:
              application/json:
                example: |
                  { "message":"Not authorized" }

traits:
  - subgroupable:
      queryParameters:
        fields:
          description: Fields to return in the request separated by comas, ID is always returned
          type: string
          example: <<example>>
          required: false
          default: id
  - pageable:
      queryParameters:
        count:
          type: number
          description: Amount of items per page
          example: 10
          required: false
          default: 10
        page:
          type: number
          description: Index of page
          example: 1
          required: false
          default: 0
  - filterable:
      queryParameters:
        filter:
          type: string
          description: List of field:value separated by comas
          example: <<example>>
          required: false
  - sortable:
      queryParameters: 
        sortby:
          type: string
          description: Field by which the list is sorted
          example: <<example>>
          required: false
          default: <<default>>
        sortdirection:
          type: string
          description: direction of sorting - ascending or descending
          example: desc
          required: false
          default: asc
  - response-404:
      responses:
        404:
          description: Resource not found
          body:
            application/json:
              example: |
                { "message":"Resource not found" }
  - response-409:
      responses:
        409:
          description: Conflict. Document already exists
          body:
            application/json:
              example: |
                { "message":"Conflict" }
  - response-400:
      responses:
        400:
          description: Bad request
          body:
            application/json:
              example: |
                { "message":"Bad request" }
  - response-401:
      responses:
        401:
          description: Missing or invalid JWT token
          body:
            application/json:
              example: |
                { "message":"Missing/incorrect JWT" }
  - rate-limited:
      responses:
        429:
          headers:
            Retry-After:
              description: When new request will be acceptable 

schemas: 
  - LoginBasicSchema: !include schemas/login/basic.schema.json
  - LoginResponseSchema: !include schemas/login/response.schema.json
  - LoginTelegramSchema: !include schemas/login/telegram.schema.json
  - LoginRestoreSchema: !include schemas/login/restore.schema.json
  - LoginRestoreSubmitSchema: !include schemas/login/restore_submit.schema.json

  - HackersCreateSchema: !include schemas/hackers/create.schema.json
  - HackersGetSchema: !include schemas/hackers/get.schema.json
  - HackersGetMeSchema: !include schemas/hackers/get.me.schema.json
  - HackersUpdateSchema: !include schemas/hackers/update.schema.json
  - HackersListSchema: !include schemas/hackers/get.list.schema.json
  - LikeReponseSchema: !include schemas/hackers/skills/like.response.schema.json
  
  - SkillsListSchema: !include schemas/skills/get.list.schema.json
  
  - EventsGetExample: !include schemas/events/get.schema.json
  - EventsListSchema: !include schemas/events/get.list.schema.json
  
  - ToggleIsSearchableSchema: !include schemas/participation/toggle_is_searchable.schema.json
  - ParticipationActivateSchema: !include schemas/participation/activate.schema.json 
  - ParticipationStatusSchema: !include schemas/participation/status.schema.json
  - ParticipationLeaveSchema: !include schemas/participation/leave.schema.json

  - EmailConfirmSchema: !include schemas/hackers/email-confirm.schema.json
  - ResendCodeSchema: !include schemas/hackers/resend-code.schema.json

/login:
  description: JWT login.
  post:
    is: [subgroupable: { example: hacker }]
    body:
      application/json:
        schema: LoginBasicSchema
        example: !include examples/login/basic.example.json
    responses:
      200:
        description: User is successfully logged in.
        body: 
          application/json:
            schema: LoginResponseSchema
            example: !include examples/login/response.example.json
      401:
        description: Incorrect login or password.

  /telegram:
    description: Login via Telegram. If user is not exists, he will be created.
    post:
      is: [subgroupable: { example: hacker } ]      
      body:
        application/json:
          schema: LoginTelegramSchema
          example: !include examples/login/telegram.example.json
      responses: 
        200:
          description: User is successfully logged in.
          body: 
            application/json:
              schema: LoginResponseSchema
              example: !include examples/login/response.example.json
        401:
          description: Not signed data from Telegram.

  /forgot:
    post:
      is: [ response-400, rate-limited ] 
      description: Generates and send a link to the user's email.
      body:
        application/json:
          schema: LoginRestoreSchema
          example: !include examples/login/restore.example.json
      responses:
        200:
          description: A link for password restore was send to the user's e-mail.
  /restore:
    post:
      is: [ response-400, rate-limited ] 
      description: Send and confirm new paasword.
      body:
        application/json:
          schema: LoginRestoreSubmitSchema
          example: !include examples/login/restore_submit.example.json
      responses:
        200:
          description: Password was successfully updated.

/hackers:
  get: 
    securedBy: [JWT]
    is: [ pageable, sortable: { example: wins, default: xp }]
    queryParameters: 
      eventId:
        description: fetch users only of specified event
        required: false
    responses: 
      200:
        body: 
          application/json:
            schema: HackersListSchema
            example: !include examples/hackers/get.list.example.json
  post:
    is: [ response-400 ]
    description: Generally the method should be used for signing a user up.
    body: 
      application/json:
        schema: HackersCreateSchema
        example: !include examples/hackers/create.example.json
    responses: 
      200:
        body:
          application/json:
            schema: HackersGetMeSchema
            example: !include examples/hackers/get.me.example.json
  /{id}:
    uriParameters: 
      id: 
        description: |
          id of hacker which profile should be shown.
          [Important!] It is possible to use "me" instead of id for fetching 
          information about logged in user for displaying his profile.
        type: number
    get: 
      securedBy: [JWT]
      is: [ response-404 ]
      description: fetches hacker's profile with id. 
      responses:
        200:
          body:
            application/json:
              schema: HackersGetSchema
              example: !include examples/hackers/get.example.json
    /{skillId}:
      uriParameters: 
        skillId: 
          description: ID of hacker's skill
          type: number
      /like:
        post:
          is: [ response-404 ]
          securedBy: [JWT]
          description: increment other hacker's skills by current user.
          responses: 
            200:
              body:
                application/json:
                  schema: LikeReponseSchema
                  example: !include examples/hackers/skills/like.response.example.json

  /me:
    get:
      securedBy: [JWT]
      is: [ response-404 ]
      description: fetches current hacker's profile. 
      responses:
        200:
          body:
            application/json:
              schema: HackersGetMeSchema
              example: !include examples/hackers/get.me.example.json

    put:
      securedBy: [JWT]
      is: [ response-400 ]
      description: updates profile's info of current hacker
      body:
        application/json:                  
          schema: HackersUpdateSchema
          example: !include examples/hackers/update.example.json
      responses: 
        200:
          description: profile was successfully updated
          body: 
            application/json:                          
              schema: HackersGetMeSchema
              example: !include examples/hackers/get.me.example.json
  /email-verification:
    description: Email verification
    post:
      is: [response-404, response-401]
      body:
        application/json:
          schema: EmailConfirmSchema
          example: !include examples/hackers/email-confirm.example.json
      responses:
        200:
          description: email was successfully verified
          body:
            application/json:
              schema: LoginResponseSchema
              example: !include examples/login/response.example.json
  /resend-confirm-code:
    description: Resends confirm code after 60s
    post:
      is: [response-404]
      body:
        application/json:
          schema: EmailConfirmSchema
          example: !include examples/hackers/email-confirm.example.json
      responses:
        200:
          description: email was successfully verified
          body:
            application/json:
              schema: LoginResponseSchema
              example: !include examples/login/response.example.json
        429:
          headers:
            Retry-After:
              description: When new request will be acceptable 
/skills:
  get:
    description: Fetches list of possible skills
    responses: 
      200:
        body:
          application/json:
            schema: SkillsListSchema
            example: !include examples/skills/get.list.example.json 

/events:
  get:
    securedBy: [ JWT ] 
    is: [ pageable ]
    queryParameters: 
      status:
        enum: 
          - open (future events)
          - applied (user applied for the hackathon)
          - confirmed (participation is confirmed by organizator)
          - activated (user checked-in the hack)
          - participated (user left hack after activation)
          - won (set by organizator)
        description: |
          coma-separated non-open statuses, if open in list, only open will be returned
        example: applied,verified,won
        default: open
      hacker_id:
        description: |
          Id of a member whose hackathons will be fetched.
          If not set current user's id will be used based on token.
    responses: 
      200:
        description: if field status contains 'win' start should be added, for 'open' - btn 'apply', for 'waiting-for' - btn 'unsubscribed'
        body:
          application/json:
            schema: EventsListSchema
            example: !include examples/events/get.list.example.json
                      
  /{eventId}:
    uriParameters:
      eventId: 
        type: number
        description: id of an event  
    get:
      securedBy: [JWT]
      description: Fetches event by id
      queryParameters: 
        hacker_id:
          description: |
            Id of a member whose hackathons will be fetched.
            If not set current user's id will be used based on token.
      is: [response-404]
      responses: 
        200:
          body:
            application/json:
              schema: EventsGetExample
              example: !include examples/events/get.example.json
    /toggle_is_searchable:
      post:
        securedBy: [JWT]    
        is: [ response-400, response-404 ]  
        responses:
          200:
            body:
              application/json:
                schema: ToggleIsSearchableSchema
                example: !include examples/participation/toggle_is_searchable.example.json
    /apply:
      post:
        securedBy: [JWT]
        is: [ response-400, response-409, response-404 ]
        responses: 
          200:

    /activate:
      post:  
        securedBy: [JWT]
        is: [ response-400, response-404 ]
        body:
          application/json:
            schema: ParticipationActivateSchema       
            example: !include examples/participation/activate.example.json
        responses:
          200:
            body:
              application/json:
                schema: ParticipationStatusSchema
                example: !include examples/participation/status.example.json
                  
    /finish:
      description: changes hacker's status from activated to participated
      post:
        securedBy: [JWT]
        is: [ response-400, response-404 ]
        responses:
          200:
            body:
              application/json:
                schema: ParticipationStatusSchema
                example: !include examples/participation/status.example.json

    /leave:
      description: |
        remove hacker's application from participation table in case of `appleid` status;
        in case of `confirmed` status, change verification status to `unverified` and set a reason for organizer.
      post: 
        securedBy: [JWT]
        is: [ response-400, response-404 ]
        body:
          application/json:
            schema: ParticipationLeaveSchema
            example: !include examples/participation/leave.example.json
        responses: 
          200:
            description: you'll receive status = `left`, `already` or `failed`
            body:
              application/json:
                schema: ParticipationStatusSchema
                example: !include examples/participation/status.example.json
